import { Meta, Canvas, Story, ArgsTable } from '@storybook/addon-docs/blocks';
import { defaultLayout } from '../.storybook/decorators';
import BlockReviews from './block-reviews';
import store from '@/.storybook/store';
import { addControls, initJsonKnobs } from '@/.storybook/helpers';

export const argTypes = {};

export const controls = {
	color: [],
	number: [],
	json: ['ctaLink', 'reviewsLink', 'items','reviews'],
};

<Meta
	title="Reviews"
	decorators={[defaultLayout]}
	component={BlockReviews}
	argTypes={addControls(argTypes, controls)}
/>

# Reviews

This module is used on the product pages.

It is used to display an overview of the reviews, three reviews and it links to the review page.

export const Template = (args, { argTypes }) => {
	initJsonKnobs(args, argTypes, controls.json);
	return {
		props: Object.keys(argTypes),
		components: { BlockReviews },
		template: '<block-reviews v-bind="$props" />',
		store,
	};
};

<Canvas withSource="none">
	<Story
		name="default"
		args={{
			ctaLink: { type: 'reviews_air_mini', isBroken: false, url: '/air-mini-reviews' },
			ctaText: 'Read more reviews',
			heading: 'We’re science-first, but our most vital data point is a happy customer.',
			items: [],
			name: 'Air Mini',
			powerreviewsPageId: 'molekule-air-mini',
			reviews: {
				results: [
					{
						ugc_id: 267425432,
						legacy_id: 193991867,
						review_id: 267425432,
						internal_review_id: 193991867,
						details: {
							comments: 'test',
							headline: 'test',
							nickname: 'russ test',
							properties: [],
							location: 'Undisclosed',
							created_date: 1582152191825,
							updated_date: 1582152192201,
							product_page_id: 'molekule-air-mini',
						},
						badges: { is_staff_reviewer: false, is_verified_buyer: false, is_verified_reviewer: false },
						media: [],
						metrics: { helpful_votes: 0, not_helpful_votes: 0, rating: 5, helpful_score: 403 },
					},
					{
						ugc_id: 266547016,
						legacy_id: 193213326,
						review_id: 266547016,
						internal_review_id: 193213326,
						details: {
							comments: 'testing review submission body',
							headline: 'testing review submission',
							nickname: 'russ',
							properties: [],
							location: 'Undisclosed',
							created_date: 1581380217434,
							updated_date: 1581380217631,
							product_page_id: 'molekule-air-mini',
						},
						badges: { is_staff_reviewer: false, is_verified_buyer: false, is_verified_reviewer: false },
						media: [],
						metrics: { helpful_votes: 0, not_helpful_votes: 0, rating: 5, helpful_score: 989 },
					},
					{
						ugc_id: 266546412,
						legacy_id: 193212827,
						review_id: 266546412,
						internal_review_id: 193212827,
						details: {
							comments: 'testing the connector for reviews into iterable.',
							headline: 'Test reviews to iterable',
							nickname: 'russell jones',
							properties: [],
							location: 'Undisclosed',
							created_date: 1581380051665,
							updated_date: 1581380052078,
							product_page_id: 'molekule-air-mini',
						},
						badges: { is_staff_reviewer: false, is_verified_buyer: false, is_verified_reviewer: false },
						media: [],
						metrics: { helpful_votes: 0, not_helpful_votes: 0, rating: 5, helpful_score: 1126 },
					},
					{
						ugc_id: 262670589,
						legacy_id: 190326800,
						review_id: 262670589,
						internal_review_id: 190326800,
						details: {
							comments: 'test',
							headline: 'test',
							nickname: 'test review',
							properties: [],
							location: 'test',
							created_date: 1575392150443,
							updated_date: 1575392151764,
							product_page_id: 'molekule-air-mini',
						},
						badges: { is_staff_reviewer: false, is_verified_buyer: false, is_verified_reviewer: false },
						media: [],
						metrics: { helpful_votes: 0, not_helpful_votes: 0, rating: 5, helpful_score: 403 },
					},
					{
						ugc_id: 280537246,
						legacy_id: 204730779,
						review_id: 280537246,
						internal_review_id: 204730779,
						details: {
							comments: 'Review.',
							headline: 'Title',
							nickname: 'Test #1',
							properties: [],
							location: 'Salt Lake City, UT',
							created_date: 1592256323130,
							updated_date: 1592256323516,
							product_page_id: 'molekule-air-mini',
						},
						badges: { is_staff_reviewer: false, is_verified_buyer: false, is_verified_reviewer: false },
						media: [],
						metrics: { helpful_votes: 0, not_helpful_votes: 0, rating: 4, helpful_score: 566 },
					},
					{
						ugc_id: 279601626,
						legacy_id: 203858026,
						review_id: 279601626,
						internal_review_id: 203858026,
						details: {
							comments: "It's a good product.",
							headline: 'A good product.',
							nickname: 'A name...',
							properties: [],
							location: 'Los Angeles, CA',
							created_date: 1591838610163,
							updated_date: 1591838610420,
							product_page_id: 'molekule-air-mini',
						},
						badges: { is_staff_reviewer: false, is_verified_buyer: false, is_verified_reviewer: false },
						media: [],
						metrics: { helpful_votes: 0, not_helpful_votes: 0, rating: 4, helpful_score: 871 },
					},
					{
						ugc_id: 279601323,
						legacy_id: 203857829,
						review_id: 279601323,
						internal_review_id: 203857829,
						details: {
							comments: 'My review.',
							headline: 'Review title.',
							nickname: 'Test #2',
							properties: [],
							location: 'Los Angeles, CA',
							created_date: 1591837571898,
							updated_date: 1591837572127,
							product_page_id: 'molekule-air-mini',
						},
						badges: { is_staff_reviewer: false, is_verified_buyer: false, is_verified_reviewer: false },
						media: [],
						metrics: { helpful_votes: 0, not_helpful_votes: 0, rating: 4, helpful_score: 670 },
					},
					{
						ugc_id: 279592564,
						legacy_id: 203852072,
						review_id: 279592564,
						internal_review_id: 203852072,
						details: {
							comments: 'Your review...',
							headline: 'Review title...',
							nickname: 'Name...',
							properties: [],
							location: 'Undisclosed',
							created_date: 1591817001813,
							updated_date: 1591987601052,
							product_page_id: 'molekule-air-mini',
						},
						badges: { is_staff_reviewer: false, is_verified_buyer: false, is_verified_reviewer: false },
						media: [],
						metrics: { helpful_votes: 0, not_helpful_votes: 0, rating: 4, helpful_score: 767 },
					},
				],
				rollup: {
					properties: [],
					rating_histogram: [0, 0, 6, 9, 4],
					average_rating: 3.89,
					review_count: 19,
					media: [],
					faceoff_positive: {
						comments: 'testing the connector for reviews into iterable.',
						headline: 'Test reviews to iterable',
						rating: 5,
					},
					faceoff_negative: { comments: 'My review…', headline: 'Review title…', rating: 3 },
					name: 'Molekule Air Mini',
					native_review_count: 19,
					syndicated_review_count: 0,
				},
				pageId: 'molekule-air-mini',
				paging: {
					total_results: 19,
					pages_total: 3,
					page_size: 8,
					current_page_number: 1,
					next_page_url:
						'/m/428472/l/en_US/product/molekule-air-mini/reviews?paging.from=8&paging.size=8&filters=&search=&sort=HighestRating&image_only=false',
				},
			},
			reviewsLink: { type: 'reviews_air_mini', isBroken: false, url: '/air-mini-reviews' },
		}}
	>
		{Template.bind({})}
	</Story>
</Canvas>

## Vue Component Props

<ArgsTable of={BlockReviews} />
